angular.module("wah_meal.controllers", [])



// TODO: indexCtrl --|-- 
.controller("indexCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = true;

	// TODO: indexCtrl --|-- $rootScope.exitApp
	$rootScope.exitApp = function(){
		var confirmPopup = $ionicPopup.confirm({
			title: "Confirm Exit",
			template: "Are you sure you want to exit?"
		});
		confirmPopup.then(function (close){
			if(close){
				ionic.Platform.exitApp();
			}
			$rootScope.closeMenuPopover();
		});
	};
	
	// TODO: indexCtrl --|-- $rootScope.changeLanguage
	$rootScope.changeLanguage = function(langKey){
		if(typeof langKey !== null){
			$translate.use(langKey);
			tmhDynamicLocale.set(langKey);
			try {
				$rootScope.language_option = langKey;
				localforage.setItem("language_option",langKey);
			}catch(e){
				localforage.setItem("language_option","en-us");
			}
		}
	};
	
	// TODO: indexCtrl --|-- $rootScope.showLanguageDialog
	var modal_language = "";
	modal_language += "<ion-modal-view>";
	modal_language += "<ion-header-bar class=\"bar bar-header bar-dark\">";
	modal_language += "<h1 class=\"title\">{{ 'Language' | translate }}</h1>";
	modal_language += "</ion-header-bar>";
	modal_language += "<ion-content class=\"padding\">";
	modal_language += "<div class=\"list\">";
	modal_language += "<ion-radio icon=\"icon ion-android-radio-button-on\" ng-model=\"language_option\" ng-value=\"'en-us'\" ng-click=\"tryChangeLanguage('en-us')\">English - US</ion-radio>";
	modal_language += "<button class=\"button button-full button-dark\" ng-click=\"closeLanguageDialog()\">{{ 'Close' | translate }}</button>";
	modal_language += "</div>";
	modal_language += "</ion-content>";
	modal_language += "</ion-modal-view>";
	
	$rootScope.languageDialog = $ionicModal.fromTemplate(modal_language,{
		scope: $scope,
		animation: "slide-in-up"
	});
	
	$rootScope.showLanguageDialog = function(){
		$rootScope.languageDialog.show();
		localforage.getItem("language_option", function(err, value){
			$rootScope.language_option = value;
		}).then(function(value){
			$rootScope.language_option = value;
		}).catch(function (err){
			$rootScope.language_option = "en-us";
		})
	};
	
	$rootScope.closeLanguageDialog = function(){
		$rootScope.languageDialog.hide();
		$rootScope.closeMenuPopover();
	};
	
	$rootScope.tryChangeLanguage = function(langKey){
		$rootScope.changeLanguage(langKey);
	};
	
	localforage.getItem("language_option", function(err, value){
		if(value === null){
			localforage.setItem("language_option","en-us");
		}else{
			$rootScope.changeLanguage(value);
		}
	}).then(function(value){
		if(value === null){
			localforage.setItem("language_option","en-us");
		}else{
			$rootScope.changeLanguage(value);
		}
	}).catch(function (err){
		localforage.setItem("language_option","en-us");
	})
	// TODO: indexCtrl --|-- $rootScope.changeFontSize
	$rootScope.changeFontSize = function(fontSize){
		if(typeof fontSize !== null){
			try {
				$rootScope.fontsize_option = $rootScope.fontsize = fontSize;
				localforage.setItem("fontsize_option",fontSize);
			}catch(e){
				localforage.setItem("fontsize_option","normal");
			}
		}
	};
	
	// TODO: indexCtrl --|-- $rootScope.showFontSizeDialog
	var modal_fontsize = "";
	modal_fontsize += "<ion-modal-view>";
	modal_fontsize += "<ion-header-bar class=\"bar bar-header bar-dark\">";
	modal_fontsize += "<h1 class=\"title\">{{ 'Font Size' | translate }}</h1>";
	modal_fontsize += "</ion-header-bar>";
	modal_fontsize += "<ion-content class=\"padding\">";
	modal_fontsize += "<div class=\"list\">";
	modal_fontsize += "<ion-radio icon=\"icon ion-android-radio-button-on\" ng-model=\"fontsize_option\" ng-value=\"'small'\" ng-click=\"tryChangeFontSize('small');\">{{ 'Small' | translate }}</ion-radio>";
	modal_fontsize += "<ion-radio icon=\"icon ion-android-radio-button-on\" ng-model=\"fontsize_option\" ng-value=\"'normal'\" ng-click=\"tryChangeFontSize('normal');\">{{ 'Normal' | translate }}</ion-radio>";
	modal_fontsize += "<ion-radio icon=\"icon ion-android-radio-button-on\" ng-model=\"fontsize_option\" ng-value=\"'large'\" ng-click=\"tryChangeFontSize('large');\">{{ 'Large' | translate }}</ion-radio>";
	modal_fontsize += "<button class=\"button button-full button-dark\" ng-click=\"closeFontSizeDialog()\">{{ 'Close' | translate }}</button>";
	modal_fontsize += "</div>";
	modal_fontsize += "</ion-content>";
	modal_fontsize += "</ion-modal-view>";
	
	$rootScope.fontSizeDialog = $ionicModal.fromTemplate(modal_fontsize,{
		scope: $scope,
		animation: "slide-in-up"
	});
	
	$rootScope.showFontSizeDialog = function(){
		$rootScope.fontSizeDialog.show();
		localforage.getItem("fontsize_option", function(err, value){
			$rootScope.fontsize_option = $rootScope.fontsize = value;
		}).then(function(value){
			$rootScope.fontsize_option = $rootScope.fontsize = value;
		}).catch(function (err){
			$rootScope.fontsize_option = $rootScope.fontsize = "normal";
		})
	};
	
	$rootScope.closeFontSizeDialog = function(){
		$rootScope.fontSizeDialog.hide();
		$rootScope.closeMenuPopover();
	};
	
	localforage.getItem("fontsize_option", function(err, value){
		if(value === null){
			localforage.setItem("fontsize_option","normal");
		}else{
			$rootScope.changeFontSize(value);
		}
	}).then(function(value){
		if(value === null){
			localforage.setItem("fontsize_option","normal");
		}else{
			$rootScope.changeFontSize(value);
		}
	}).catch(function (err){
		console.log(err);
		localforage.setItem("fontsize_option","normal");
	})
	
	
	$rootScope.tryChangeFontSize = function(val){
		$rootScope.changeFontSize(val);
	};
	
	// TODO: indexCtrl --|-- $rootScope.clearCacheApp
	$rootScope.clearCacheApp = function(){
		var confirmPopup = $ionicPopup.confirm({
			title: "Confirm",
			template: "Are you sure you want to clear cache?"
		});
		confirmPopup.then(function (close){
			if(close){
				localforage.keys().then(function(keys) {
					for(var e = 0; e < keys.length ; e++) {
						localforage.setItem(keys[e],[]);
					}
					$state.go("wah_meal.dashboard");
				}).catch(function(err) {
					$state.go("wah_meal.dashboard");
				});
			}
			$rootScope.closeMenuPopover();
		});
	};
	$rootScope.last_edit = "-" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: indexCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: indexCtrl --|-- $scope.openURL
	// open external browser 
	$rootScope.openURL = function($url){
		window.open($url,"_system","location=yes");
	};
	// TODO: indexCtrl --|-- $scope.openAppBrowser
	// open AppBrowser
	$rootScope.openAppBrowser = function($url){
		var appBrowser = window.open($url,"_blank","hardwareback=Done,hardwareback=Done,toolbarposition=top,location=yes");
	
		appBrowser.addEventListener("loadstart",function(){
			navigator.notification.activityStart("Please Wait", "Its loading....");
		});
	
	
		appBrowser.addEventListener("loadstop",function(){
			navigator.notification.activityStop();
		});
	
	
		appBrowser.addEventListener("loaderror",function(){
			navigator.notification.activityStop();
			window.location = "retry.html";
		});
	
	
		appBrowser.addEventListener("exit",function(){
			navigator.notification.activityStop();
		});
	
	};
	
	
	// TODO: indexCtrl --|-- $scope.openWebView
	// open WebView
	$rootScope.openWebView = function($url){
		var appWebview = window.open($url,"_blank","location=no,toolbar=no");
	
		appWebview.addEventListener("loadstart",function(){
			navigator.notification.activityStart("Please Wait", "Its loading....");
		});
	
	
		appWebview.addEventListener("loadstop",function(){
			navigator.notification.activityStop();
		});
	
	
		appWebview.addEventListener("loaderror",function(){
			navigator.notification.activityStop();
			window.location = "retry.html";
		});
	
	
		appWebview.addEventListener("exit",function(){
			navigator.notification.activityStop();
		});
	
	};
	
	
	// TODO: indexCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: indexCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: indexCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {

			//read Session from file storage

			
				var req = {
					method: 'GET',
					url:'sessionFiles.php?read_session_file=loginSession',
					headers: {
					  'Content-Type': 'application/x-www-form-urlencoded',
					  'Accept': 'application/json'
					}
				}

				$http(req).then(function(resp){
					if(resp.data.status == 1)
					{
						if(resp.data.file_data && resp.data.file_data.ima_session && resp.data.file_data.ima_session.length > 0){
							localforage.setItem("ima_session", resp.data.file_data);
							localStorage.setItem("token_session", resp.data.file_data);
						}
					}else{
							$rootScope.logoutUser();
							//localStorage.removeItem("token_session");
					}
				});



			main_side_nav();
			
			var eventMethod = window.addEventListener ? "addEventListener" : "attachEvent";
			var eventer = window[eventMethod];
			var messageEvent = eventMethod == "attachEvent" ? "onmessage" : "message";

			// Listen to message from child window
			eventer(messageEvent,function(e) {
			  console.log('parent received message!:  ',e.data);

			  var link_txt = e.data;
			  var link_txt_arr = link_txt.toString().split("#");
			  

			  if(link_txt_arr.length == 2)
			  {
				$rootScope.restaurant_id = link_txt_arr[1];
			  }

			  
			 
			  switch (link_txt_arr[0]) {

				  case "home":
					$state.go("wah_meal.dashboard");
				  break;

				  case "about":
					$state.go("wah_meal.about_us");
				  break;

				  case "help":
					$state.go("wah_meal.faqs");
				  break;

				  case "contact":
					$state.go("wah_meal.menu_one");
				  break;

				  case "terms":
					$state.go("wah_meal.menu_two");
				  break;

				  case "refund":
					$state.go("wah_meal.page1");
				  break;

				  case "privacy":
					$state.go("wah_meal.page2");
				  break;

				  case "profile":
					$state.go("wah_meal.profile");
				  break;

				  case "orders":
					$state.go("wah_meal.my_orders");
				  break;

				  case "track":
					$state.go("wah_meal.track");
				  break;

				  case "restaurant":
					$state.go("wah_meal.restaurant");
				  break;

				  case "logout":
					$rootScope.logoutUser();
				  break;
			   
			  }


			});


		} catch(e){
			console.log("%cerror: %cPage: `index` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: side_menusCtrl --|-- 
.controller("side_menusCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = true;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "-" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: side_menusCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: side_menusCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: side_menusCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 
	
	var popover_template = "";
	popover_template += "<ion-popover-view class=\"fit\">";
	popover_template += "	<ion-content>";
	popover_template += "		<ion-list>";
	popover_template += "			<a  class=\"item dark-ink\" ng-href=\"#/wah_meal/about_us\" ng-click=\"popover.hide()\">";
	popover_template += "			{{ 'About Us' | translate }}";
	popover_template += "			</a>";
	popover_template += "			<a  class=\"item dark-ink\" ng-click=\"showLanguageDialog()\" >";
	popover_template += "			{{ 'Language' | translate }}";
	popover_template += "			</a>";
	popover_template += "		</ion-list>";
	popover_template += "	</ion-content>";
	popover_template += "</ion-popover-view>";
	
	
	$scope.popover = $ionicPopover.fromTemplate(popover_template,{
		scope: $scope
	});
	
	$scope.closePopover = function(){
		$scope.popover.hide();
	};
	
	$rootScope.closeMenuPopover = function(){
		$scope.popover.hide();
	};
	
	$scope.$on("$destroy", function(){
		$scope.popover.remove();
	});

	// TODO: side_menusCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
			
		} catch(e){
			console.log("%cerror: %cPage: `side_menus` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: about_usCtrl --|-- 
.controller("about_usCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: about_usCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: about_usCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: about_usCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: about_usCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()
$scope.$on("$ionicView.afterEnter", function (){ 
	iuser_id = $rootScope.current_user.uname;
	document.getElementById('iframe_about').src = "https://wahmeal.in/cust_app/about.php";

 });			
		} catch(e){
			console.log("%cerror: %cPage: `about_us` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: dashboardCtrl --|-- 
.controller("dashboardCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale,$compile){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: dashboardCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: dashboardCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: dashboardCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: dashboardCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()

var uname_id, iuser_id;
$scope.current_user = {} ;

	console.log(11111);
    
   $ionicLoading.show();
   
   localforage.getItem("ima_session", function(err, ima_session){
	 
        if(jQuery.isEmptyObject(JSON.parse(ima_session))){
			// failed
			console.log("logout")
			$state.go("wah_meal.form_login");

		}else{
		    try {
				$rootScope.token_session = ima_session;		
			}catch(e){
		      console.log(e);
            }
		}
        
	}).then(function(ima_session){
	   
		    try {
				$rootScope.token_session = ima_session;			
			}catch(e){
		       console.log(e);
            }     

			var form = {};
			form.auth_token = $rootScope.token_session;
			
			var req = {
				method: 'POST',
				url: api_end_point+'check_login',
				headers: {
				  'Content-Type': 'application/x-www-form-urlencoded',
				  'Accept': 'application/json'
				},
				data: $httpParamSerializer(form)
			}
            
            $http(req).then(function(resp){
                
                if(resp.data.status == 0){
               	    $ionicHistory.nextViewOptions({
                		disableAnimate: true,
                		disableBack: true
                	});
        			$state.go("wah_meal.form_login");
                }else{
                    $scope.current_user = resp.data.user_data ;
                    $rootScope.current_user = resp.data.user_data ;
                  	iuser_id = $rootScope.current_user.id;
					//console.log($rootScope.current_user);


					
					var form = {};
					form.auth_token = $rootScope.token_session;
					
					var req = {
						method: 'POST',
						url: api_end_point+'my_courses_get',
						headers: {
						  'Content-Type': 'application/x-www-form-urlencoded',
						  'Accept': 'application/json'
						},
						data: $httpParamSerializer(form)
					}

					$http(req).then(function(resp){

						if(resp.data.status == 1)
						{
							//console.log(resp.data.all_courses);



							//Save session file - courses
				var form = {};
				form.file_data = resp.data;
			
				var req = {
					method: 'POST',
					url:'sessionFiles.php?create_session_file=coursesSession',
					headers: {
					  'Content-Type': 'application/x-www-form-urlencoded',
					  'Accept': 'application/json'
					},
					data: $httpParamSerializer(form)
				}

				$http(req).then(function(resp){
					if(resp.data.status == 1)
					{
						console.log('coursesSession file created');
					}
				});



							localforage.setItem("my_courses_session", resp.data);
							document.getElementById('my_course_count').innerHTML = resp.data.count;
							var courses_html = "";
							var my_course_count_not_live = 0;
							resp.data.all_courses.forEach(function(index,item)
							{
								console.log(resp.data.all_courses[item].title);
								
								if(resp.data.all_courses[item].is_only_live_class == 0)
								{

									//download thumbnails
									var form_data = new FormData();
									form_data.append('thumbnail_url', resp.data.all_courses[item].thumbnail);
									fetch('thumbnailFiles.php?download_thumbnail=1', {
										method: "POST",
										body: form_data
									}).then((function(res) {
										//console.log(res);
									}));

									courses_html += '<div class="col-sm-12 col-md-4 col-lg-3 my-1">';
									courses_html +=     '<div class="card" style="width:100%;">';
									courses_html +=	  '<img class="img-thumbnail p-1" src="'+resp.data.all_courses[item].thumbnail+'" alt="Card image" style="width:100%; height:236.5px; border-bottom:none;">';
									courses_html +=	  '<div class="card-body">';
									courses_html +=				 '<h6 class="card-title">'+resp.data.all_courses[item].title+'..</h6>';
									//courses_html +=				 '<div class="progress mb-2">';
									//courses_html +=					'<div class="progress-bar progress-bar-striped " style="width:'+resp.data.all_courses[item].completion+'%"></div>';
									//courses_html +=				  '</div>';
									//courses_html +=				  '<div class="card-text mb-1">'+resp.data.all_courses[item].completion+'% Completed</div>';
									courses_html +=				 '<button ng-click="gotocourse('+resp.data.all_courses[item].id+','+'\''+resp.data.all_courses[item].title+'\''+')" class="btn btn-primary btn-block">Start Lesson</button>';
									courses_html +=			'</div>';
									courses_html +=	      '</div>';
									courses_html +=	     '</div>';

									my_course_count_not_live++;
								}

								



							});

							
							document.getElementById('my_course_count').innerHTML = my_course_count_not_live;

							var temp = $compile(angular.element(courses_html))($scope);
							angular.element(document.getElementById('my_courses_list')).append(temp);
						}
						else
						{
							var alertPopup = $ionicPopup.alert({
								title: "Ops, sorry no course found",
								template: "Visit "+web_url,
							}); 
							document.getElementById('my_course_count').innerHTML = '0';
						}

					},function(resp){   
						$state.go("wah_meal.form_login"); 
						var alertPopup = $ionicPopup.alert({
							title: "Ops, error!",
							template: "Server Busy!!!",
						});  
					}).finally(function(){   
						$timeout(function() {
							$ionicLoading.hide();
						}, 500);          
					}); 






                }
                       
                
            },function(resp){   
                

	//read Session from file storage

			
	var req = {
		method: 'GET',
		url:'sessionFiles.php?read_session_file=coursesSession',
		headers: {
		  'Content-Type': 'application/x-www-form-urlencoded',
		  'Accept': 'application/json'
		}
	}

	$http(req).then(function(resp){
		if(resp.data.status == 1)
		{
			if(resp.data.file_data){
				localforage.setItem("my_courses_session", JSON.parse(resp.data.file_data));
			}
		}
	});

				localforage.getItem("my_courses_session", function(err, my_courses_session){
         


					if(my_courses_session === null){
						// failed
						$state.go("wah_meal.form_login");
					}else{
						try {
							$rootScope.my_courses_session = my_courses_session;		
						}catch(e){
						  console.log(e);
						}
					}
					
				}).then(function(my_courses_session){

					
				   
						try {
							$rootScope.my_courses_session = my_courses_session;			
						}catch(e){
						   console.log(e);
						}     
				
						var resp = {};
						resp.data = $rootScope.my_courses_session;
					  
						document.getElementById('my_course_count').innerHTML = resp.data.count;
						var courses_html = "";
						var my_course_count_not_live = 0;
						resp.data.all_courses.forEach(function(index,item)
						{
							//console.log(resp.data.all_courses[item].title);
							
							if(resp.data.all_courses[item].is_only_live_class == 0)
							{
								resp.data.all_courses[item].thumbnail = 'session/thumbnails/'+resp.data.all_courses[item].thumbnail.split('/').reverse()[0];

								courses_html += '<div class="col-sm-12 col-md-4 col-lg-3 my-1">';
								courses_html +=     '<div class="card" style="width:100%;">';
								courses_html +=	  '<img class="img-thumbnail p-1" src="'+resp.data.all_courses[item].thumbnail+'" alt="Card image" style="width:100%; height:236.5px; border-bottom:none;">';
								courses_html +=	  '<div class="card-body">';
								courses_html +=				 '<h6 class="card-title">'+resp.data.all_courses[item].title+'..</h6>';
								//courses_html +=				 '<div class="progress mb-2">';
								//courses_html +=					'<div class="progress-bar progress-bar-striped " style="width:'+resp.data.all_courses[item].completion+'%"></div>';
								//courses_html +=				  '</div>';
								//courses_html +=				  '<div class="card-text mb-1">'+resp.data.all_courses[item].completion+'% Completed</div>';
								courses_html +=				 '<button ng-click="gotocourse('+resp.data.all_courses[item].id+','+'\''+resp.data.all_courses[item].title+'\''+')" class="btn btn-primary btn-block">Start Lesson</button>';
								courses_html +=			'</div>';
								courses_html +=	      '</div>';
								courses_html +=	     '</div>';

								my_course_count_not_live++;

							}
				
				
				
				
						});

						document.getElementById('my_course_count').innerHTML = my_course_count_not_live;

						var temp = $compile(angular.element(courses_html))($scope);
						angular.element(document.getElementById('my_courses_list')).append(temp);
				
								 
						
				// localforage error        
				}).catch(function(err){
					   console.log(err);
				})










            }).finally(function(){   
        		$timeout(function() {
        			$ionicLoading.hide();
        		}, 500);            
            });              
            
    // localforage error        
	}).catch(function(err){
	       console.log(err);
	})
 

	$rootScope.gotocourse = function(c_id, c_title){
		$rootScope.course_id = c_id;
		$rootScope.course_title = c_title;
		// tracking
		lc_obj_index = lc_sessions.findIndex((obj => obj.id === lc_session_id));
		var page_data_arr = [];
		page_data_arr.push({
			course_id: c_id,
			course: c_title.trim(),
			at_time : new Date().getTime(),
			lesson: []
		});
		lc_sessions[lc_obj_index].data.page_data = page_data_arr;
		localStorage.setItem("lc_sessions", JSON.stringify(lc_sessions));
		//tracking
		$state.go("wah_meal.my_orders");
   }
   


$rootScope.setLocation = function(){
 	document.getElementById("iframe_home").contentWindow.postMessage('setlocation', '*'); 
}

$rootScope.navPage = function(page){
  console.log(page);
 	//$state.go(page); 
}


$rootScope.logoutUser = function(){
	console.log(1);
    delete $rootScope.current_user ;
    delete $scope.current_user ;
    
    var http_value = {};
    
    localforage.setItem("ima_session", JSON.stringify(http_value));    


	//Save session file -login
var form = {};
form.file_data = JSON.stringify({ima_session:''});

var req = {
	method: 'POST',
	url:'sessionFiles.php?create_session_file=loginSession',
	headers: {
	  'Content-Type': 'application/x-www-form-urlencoded',
	  'Accept': 'application/json'
	},
	data: $httpParamSerializer(form)
}

$http(req).then(function(resp){
	if(resp.data.status == 1)
	{
		console.log('loginSession logout file created');
	}
});
    
      $ionicHistory.nextViewOptions({
        disableAnimate: true,
        disableBack: true
    });
    
    $state.go("wah_meal.form_login");
}	

//tracking

var lc_obj_index = lc_sessions.findIndex((obj => obj.id === lc_session_id));
jQuery("#lc_session_obj_index").val(lc_obj_index);


lc_users_list = [];

for(i=0; i < lc_sessions.length; i++)
{
	
	if(lc_users_list.findIndex((obj => obj.id === lc_sessions[i].data.lc_user)) < 0)
	{
		lc_users_list.push({
			id: lc_sessions[i].data.lc_user,
			text: lc_sessions[i].data.lc_user
		})
	}
	
}


if(lc_sessions[lc_obj_index].status == 0)
{
	DateAndTime();
	dateTimer = setInterval("DateAndTime()", 1000);
	jQuery('.js-example-basic-single').select2({ 
		width: '100%', 
		dropdownParent: jQuery("#startSession"), 
		placeholder:'Select User', 
		tags:true,
		data: lc_users_list
	});
	jQuery('#startSession').modal({
		backdrop: 'static',
		keyboard: false
	});
}




if($rootScope.last_course_id > 0 && $rootScope.last_lesson_id > 0)
{
	lc_course_obj_index = lc_sessions[lc_obj_index].data.page_data.findIndex((obj => obj.course_id === $rootScope.last_course_id));
	var lesson_data_obj_index = lc_sessions[lc_obj_index].data.page_data[lc_course_obj_index].lesson.findIndex((obj => obj.lesson_id === $rootScope.last_lesson_id));
	lc_sessions[lc_obj_index].data.page_data[lc_course_obj_index].lesson[lesson_data_obj_index].end_time = new Date().getTime();
	localStorage.setItem("lc_sessions", JSON.stringify(lc_sessions));
}






		} catch(e){
			console.log("%cerror: %cPage: `dashboard` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: faqsCtrl --|-- 
.controller("faqsCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: faqsCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: faqsCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: faqsCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: faqsCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
main_side_nav()
$scope.$on("$ionicView.afterEnter", function (){ 
	iuser_id = $rootScope.current_user.uname;
	document.getElementById('iframe_help').src = "https://wahmeal.in/cust_app/help.php?username="+iuser_id;

 });			
		} catch(e){
			console.log("%cerror: %cPage: `faqs` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: form_loginCtrl --|-- 
.controller("form_loginCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "page_builder" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: form_loginCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: form_loginCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: form_loginCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	
	// Form Request
	// code 

	// TODO: form_loginCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
			$scope.$on("$ionicView.afterEnter", function (){  

				document.getElementById("currentYear").innerHTML = new Date().getFullYear();

				if(location_allowed == 1)
				{
					var latitude = location_lat;
					var longitude = location_long;
				}
				


			});

			
$scope.submitUser = function(form){
    
    $ionicLoading.show({
		template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
	});
    
    if( angular.isDefined(form)){
        
		var email = form.email || "demo";
		var pwd = form.password || "demo";
		form.type = 1;
		form.lat = location_lat;
		form.long = location_long;

		//console.log(form);

		
		

		var req = {
			method: 'POST',
			url: api_end_point+'login_get',
			headers: {
			  'Content-Type': 'application/x-www-form-urlencoded',
			  'Accept': 'application/json'
			},
			data: $httpParamSerializer(form)
		}

	
/*
		var http_value = "Basic " + base64.encode(uname + ":" + pwd);
		$http.defaults.headers.common["X-Authorization"] = http_value;
		 $http.get("https://www.wahmeal.in/cust_app/rest-api.php?json=auth").then(function(resp){
*/
       
			$http(req).then(function(resp){
            if(resp.data.status == 201){
    			var alertPopup = $ionicPopup.alert({
    				title: "Failed",
    				template: resp.data.status_msg,
    			});
            }else{
           	    $ionicHistory.nextViewOptions({
            		disableAnimate: true,
            		disableBack: true
            	});

//Save session file -login
				var form = {};
				form.file_data = JSON.stringify({ima_session:resp.data.token});
			
				var req = {
					method: 'POST',
					url:'sessionFiles.php?create_session_file=loginSession',
					headers: {
					  'Content-Type': 'application/x-www-form-urlencoded',
					  'Accept': 'application/json'
					},
					data: $httpParamSerializer(form)
				}

				$http(req).then(function(resp){
					if(resp.data.status == 1)
					{
						console.log('loginSession file created');
					}
				});


                localforage.setItem("ima_session", resp.data.token);
				localStorage.setItem("token_session", resp.data.token);
				console.log(resp.data.token);
				setTimeout($state.go("wah_meal.dashboard"), 5000);
                
            }
        },function(resp){   
            
			$timeout(function() {
				$ionicLoading.hide();
                
        		var alertPopup = $ionicPopup.alert({
        			title: "Ops, error!",
        			template: "Server Busy!!!",
        		});
                            
			}, 500); 
                        
            
        }).finally(function(){   
            
			$timeout(function() {
				$ionicLoading.hide();
			}, 500);          
              
        });    
    }
    
	$timeout(function() {
	   $ionicLoading.hide();
	}, 1000);  
    
}   

jQuery('#startSession').modal('hide');
clearInterval(dateTimer);
			
		} catch(e){
			console.log("%cerror: %cPage: `form_login` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: form_orderCtrl --|-- 
.controller("form_orderCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "page_builder" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: form_orderCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: form_orderCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: form_orderCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	
	// Form Request
	//order
	$scope.form_order= {};
	// TODO: form_orderCtrl --|-- $scope.submitOrder
	$scope.submitOrder = function(){
		// animation loading 
		$ionicLoading.show();
	
		var $messages, $title = null;
		$http({
				method:"POST",
				url: "https://www.wahmeal.in/cust_app/rest-api.php?json=submit&form=order",
				data: $httpParamSerializer($scope.form_order),  // pass in data as strings
				headers: {"Content-Type":"application/x-www-form-urlencoded"}  // set the headers so angular passing info as form data (not request payload)
			})
			.then(function(response) {
				$messages = response.data.message;
				$title = response.data.title;
			},function(response){
				$messages = response.statusText;
				$title = response.status;
			}).finally(function(){
				// event done, hidden animation loading
				$timeout(function() {
					$ionicLoading.hide();
					if($messages !== null){
						// message
					var alertPopup = $ionicPopup.alert({
						title: $title,
						template: $messages,
					});
						// clear input
						$scope.form_order.service = "";
						$scope.form_order.note = "";
					}
			}, 500);
		});
	};
	// code 

	// TODO: form_orderCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
main_side_nav()			
		} catch(e){
			console.log("%cerror: %cPage: `form_order` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: form_userCtrl --|-- 
.controller("form_userCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "page_builder" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: form_userCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: form_userCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: form_userCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	
	// Form Request
	//user
	$scope.form_user= {};
	// TODO: form_userCtrl --|-- $scope.submitUser
	$scope.submitUser = function(){
		// animation loading 
		$ionicLoading.show();
	
		var $messages, $title = null;
		$http({
				method:"POST",
				url: "https://www.wahmeal.in/cust_app/rest-api.php?json=submit&form=user",
				data: $httpParamSerializer($scope.form_user),  // pass in data as strings
				headers: {"Content-Type":"application/x-www-form-urlencoded"}  // set the headers so angular passing info as form data (not request payload)
			})
			.then(function(response) {
				$messages = response.data.message;
				$title = response.data.title;
			},function(response){
				$messages = response.statusText;
				$title = response.status;
			}).finally(function(){
				// event done, hidden animation loading
				$timeout(function() {
					$ionicLoading.hide();
					if($messages !== null){
						// message
					var alertPopup = $ionicPopup.alert({
						title: $title,
						template: $messages,
					});
						// clear input
						$scope.form_user.fullname = "";
						$scope.form_user.uname = "";
						$scope.form_user.pwd = "";
						$scope.form_user.address = "";
						$scope.form_user.type_ic = "";
						$scope.form_user.no_ic = "";
						$scope.form_user.phone = "";
						$scope.form_user.email = "";
					}
			}, 500);
		});
	};
	// code 

	// TODO: form_userCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");			
		} catch(e){
			console.log("%cerror: %cPage: `form_user` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: menu_oneCtrl --|-- 
.controller("menu_oneCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: menu_oneCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: menu_oneCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: menu_oneCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: menu_oneCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()
$scope.$on("$ionicView.afterEnter", function (){ 
	iuser_id = $rootScope.current_user.uname;
	document.getElementById('iframe_contact').src = "https://wahmeal.in/cust_app/contact.php";

 });			
		} catch(e){
			console.log("%cerror: %cPage: `menu_one` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: menu_twoCtrl --|-- 
.controller("menu_twoCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: menu_twoCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: menu_twoCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: menu_twoCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: menu_twoCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()
$scope.$on("$ionicView.afterEnter", function (){ 
	iuser_id = $rootScope.current_user.uname;
	document.getElementById('iframe_terms').src = "https://wahmeal.in/cust_app/terms-service.php";

 });			
		} catch(e){
			console.log("%cerror: %cPage: `menu_two` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: my_ordersCtrl --|-- 
.controller("my_ordersCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale,$compile){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "page" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: my_ordersCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: my_ordersCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: my_ordersCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: my_ordersCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
main_side_nav()


var courseLessons;
$scope.$on("$ionicView.afterEnter", function (){ 

	if($rootScope.course_title.length >43)
	{
		document.getElementById('page_title').innerHTML = $rootScope.course_title.substring(0,44)+'..';
	}
	else
	{
		document.getElementById('page_title').innerHTML = $rootScope.course_title;

	}

	document.getElementById('lesson_file').innerHTML = "";
	document.getElementById('lesson_summary').innerHTML = "";
	document.getElementById('lesson_title').style.display = "none";

	$ionicLoading.show();



	localforage.getItem("ima_session", function(err, ima_session){
		
		if(ima_session === null){
			// failed
			$state.go("wah_meal.form_login");
		}else{
			try {
				$rootScope.token_session = ima_session;		
			}catch(e){
			  console.log(e);
			}
		}
		
	}).then(function(ima_session){
	   
			try {
				$rootScope.token_session = ima_session;			
			}catch(e){
			   console.log(e);
			}     
	
			var form = {};
			form.auth_token = $rootScope.token_session;
			
			var req = {
				method: 'POST',
				url: api_end_point+'check_login',
				headers: {
				  'Content-Type': 'application/x-www-form-urlencoded',
				  'Accept': 'application/json'
				},
				data: $httpParamSerializer(form)
			}
			
			$http(req).then(function(resp){
				
				if(resp.data.status == 0){
					   $ionicHistory.nextViewOptions({
						disableAnimate: true,
						disableBack: true
					});
					$state.go("wah_meal.form_login");
				}else{



	var form = {};
	form.auth_token = $rootScope.token_session;
	form.course_id = $rootScope.course_id;
	
	var req = {
		method: 'POST',
		url: api_end_point+'course_details_by_id_get',
		headers: {
		  'Content-Type': 'application/x-www-form-urlencoded',
		  'Accept': 'application/json'
		},
		data: $httpParamSerializer(form)
	}

	$http(req).then(function(resp){

		if(resp.data.status > 0)
		{
			//console.log(resp.data.all_courses);



	//Save session file - courses
	var form = {};
	form.file_data = resp.data;

	var req = {
		method: 'POST',
		url:'sessionFiles.php?create_session_file=course_'+$rootScope.course_id,
		headers: {
		  'Content-Type': 'application/x-www-form-urlencoded',
		  'Accept': 'application/json'
		},
		data: $httpParamSerializer(form)
	}

	$http(req).then(function(resp){
		if(resp.data.status == 1)
		{
			console.log('lessionSession file created');
		}
	});




			localforage.setItem("course_"+$rootScope.course_id, resp.data);
			courseLessons = resp.data;
			var section_html = "";

			console.log(resp.data.course_data[0].sections);
			var all_sections = resp.data.course_data[0].sections;
			var downloadable = 0;
			var i=0;
			all_sections.forEach(function(index,item)
			{
				console.log(all_sections[item].title);
				if(i == 0)
				{
					var show_collapse = "show";
				}
				else
				{
					var show_collapse = "";
				}
				section_html += '<div class="card my-2">';
				section_html +=		'<div class="card-header px-2" data-toggle="collapse" href="#collapseSection_'+all_sections[item].id+'">';
				section_html += '<span class="card-link" >'+all_sections[item].title+'</span>';
				section_html += '</div><div id="collapseSection_'+all_sections[item].id+'" class="collapse '+show_collapse+'" data-parent="#accordion">';
				section_html += '<div class="card-body p-0" ><div class="list-group rounded-0">';

				all_sections[item].lessons.forEach(function(index2,item2)
				{

					console.log(all_sections[item].lessons[item2].title);

					var lesson_icon, type_text, src;
					var lesson_type = all_sections[item].lessons[item2].lesson_type;
					if(all_sections[item].lessons[item2].lesson_type == "video")
					{
						if(all_sections[item].lessons[item2].video_type == "html5" || all_sections[item].lessons[item2].video_type == "system_video")
						{
							downloadable = 1;
						}
						else
						{
							downloadable = 0;
							
						}
						lesson_icon = "youtube";
						type_text = all_sections[item].lessons[item2].duration;
						src = all_sections[item].lessons[item2].video_url;
					}
					else if(all_sections[item].lessons[item2].lesson_type == "other")
					{
						if(all_sections[item].lessons[item2].attachment_type == "img")
						{
							lesson_icon = "image";
							downloadable = 1;
						}
						else
						{
							lesson_icon = "file-text";
							downloadable = 1;
						}
						type_text = "Attachment";
						src = all_sections[item].lessons[item2].attachment;
					}
					else
					{
						lesson_icon = "help-circle";
						type_text = "Quiz";
						downloadable = 0;
						src = "";
					}

					var lesson_completed;
					if(all_sections[item].lessons[item2].is_completed == 1)
					{
						lesson_completed = "checked disabled";
					}

					var lesson_id = all_sections[item].lessons[item2].id;

					section_html +=	'<div id="all_sections[item].lessons[item2].id" class="list-group-item px-2">';
					section_html +=	'<div class="form-check-inline">';
					//section_html +=		  '<input '+lesson_completed+' type="checkbox" class="form-check-input" value="">';
					section_html += '<span ng-click="start_lesson('+item+','+'\''+item2+'\''+')" >'+all_sections[item].lessons[item2].title+'</span>';
					section_html +=	'</div>';
					section_html +=	'<div class="d-block">';
					section_html +=		'<i class="feather-'+lesson_icon+' mr-2"></i> '+type_text;
					if(downloadable == 1)
					{
						//section_html +=		'<i id="download_lesson_'+lesson_id+'" ng-click="download_lesson('+'\''+src+'\', \''+lesson_type+'\','+lesson_id+')" class="feather-download color-orange float-right"></i>';
					}
					section_html +=	'</div>';
					section_html +=	'</div>';

				});

				section_html += '</div></div></div></div>';
				i++;

			});
			
			

			var temp = $compile(angular.element(section_html))($scope);
			angular.element(document.getElementById('accordion')).append(temp);
			document.querySelector('.row-offcanvas').classList.toggle("active");
		}
		else
		{
			var alertPopup = $ionicPopup.alert({
				title: "Ops, No sections added yet.",
				template: "Try after sometime",
			}); 
			
		}

	},function(resp){   
		//$state.go("wah_meal.form_login"); 
		var alertPopup = $ionicPopup.alert({
			title: "Ops, error!",
			template: "Server Busy!!!",
		});  
	}).finally(function(){   
		$timeout(function() {
			$ionicLoading.hide();
		}, 500);          
	});

}
                   
            
},function(resp){   

//////



	//read Session from file storage

			
	var req = {
		method: 'GET',
		url:'sessionFiles.php?read_session_file=course_'+$rootScope.course_id,
		headers: {
		  'Content-Type': 'application/x-www-form-urlencoded',
		  'Accept': 'application/json'
		}
	}

	$http(req).then(function(resp){
		if(resp.data.status == 1)
		{
			if(resp.data.file_data){
				localforage.setItem("course_"+$rootScope.course_id, JSON.parse(resp.data.file_data));
			}
		}
	});


localforage.getItem("course_"+$rootScope.course_id, function(err, coursedata){
     
	if(coursedata === null){
		// failed
		$state.go("wah_meal.form_login");
	}else{
		try {
			$rootScope.coursedata = coursedata;		
		}catch(e){
		  console.log(e);
		}
	}
	
}).then(function(coursedata){


	courseLessons = coursedata;
	var section_html = "";

	console.log(coursedata.course_data[0].sections);
	var all_sections = coursedata.course_data[0].sections;
	var downloadable = 0;
	var i=0;
	all_sections.forEach(function(index,item)
	{
		console.log(all_sections[item].title);
		if(i == 0)
		{
			var show_collapse = "show";
		}
		else
		{
			var show_collapse = "";
		}
		section_html += '<div class="card my-2">';
		section_html +=		'<div class="card-header px-2" data-toggle="collapse" href="#collapseSection_'+all_sections[item].id+'">';
		section_html += '<span class="card-link" >'+all_sections[item].title+'</span>';
		section_html += '</div><div id="collapseSection_'+all_sections[item].id+'" class="collapse '+show_collapse+'" data-parent="#accordion">';
		section_html += '<div class="card-body p-0" ><div class="list-group rounded-0">';

		all_sections[item].lessons.forEach(function(index2,item2)
		{

			console.log(all_sections[item].lessons[item2].title);

			var lesson_icon, type_text, src;
			var lesson_type = all_sections[item].lessons[item2].lesson_type;
			if(all_sections[item].lessons[item2].lesson_type == "video")
			{
				if(all_sections[item].lessons[item2].video_type == "html5" || all_sections[item].lessons[item2].video_type == "system_video")
				{
					downloadable = 1;
				}
				else
				{
					downloadable = 0;
					
				}
				lesson_icon = "youtube";
				type_text = all_sections[item].lessons[item2].duration;
				src = all_sections[item].lessons[item2].video_url;
			}
			else if(all_sections[item].lessons[item2].lesson_type == "other")
			{
				if(all_sections[item].lessons[item2].attachment_type == "img")
				{
					lesson_icon = "image";
					downloadable = 1;
				}
				else
				{
					lesson_icon = "file-text";
					downloadable = 1;
				}
				type_text = "Attachment";
				src = all_sections[item].lessons[item2].attachment;
			}
			else
			{
				lesson_icon = "help-circle";
				type_text = "Quiz";
				downloadable = 0;
				src = "";
			}

			var lesson_completed;
			if(all_sections[item].lessons[item2].is_completed == 1)
			{
				lesson_completed = "checked disabled";
			}

			var lesson_id = all_sections[item].lessons[item2].id;

			section_html +=	'<div id="all_sections[item].lessons[item2].id" class="list-group-item px-2">';
			section_html +=	'<div class="form-check-inline">';
			//section_html +=		  '<input '+lesson_completed+' type="checkbox" class="form-check-input" value="">';
			section_html += '<span ng-click="start_lesson('+item+','+'\''+item2+'\''+')" >'+all_sections[item].lessons[item2].title+'</span>';
			section_html +=	'</div>';
			section_html +=	'<div class="d-block">';
			section_html +=		'<i class="feather-'+lesson_icon+' mr-2"></i> '+type_text;
			if(downloadable == 1)
			{
				//section_html +=		'<i id="download_lesson_'+lesson_id+'" ng-click="download_lesson('+'\''+src+'\', \''+lesson_type+'\','+lesson_id+')" class="feather-download color-orange float-right"></i>';
			}
			section_html +=	'</div>';
			section_html +=	'</div>';

		});

		section_html += '</div></div></div></div>';
		i++;

	});
	
	

	var temp = $compile(angular.element(section_html))($scope);
	angular.element(document.getElementById('accordion')).append(temp);
	document.querySelector('.row-offcanvas').classList.toggle("active");

	// localforage error        
}).catch(function(err){
	console.log(err);
})


}).finally(function(){   
	$timeout(function() {
		$ionicLoading.hide();
	}, 500);            
});              

// localforage error        
}).catch(function(err){
console.log(err);
})



 });	
 
 
 $scope.toggleCourseLesson = function() {
	document.querySelector('.row-offcanvas').classList.toggle("active");
};


$scope.download_lesson = function(src, type, this_id)
{
	if(type!="" && src!="")
	{
		src = src.replace("index.php/", "");
		var src_arr = src.split("/");
		src = src_arr[src_arr.length - 1];
		var file_url;
		if(type == 'video')
		{
			file_url = web_url+'uploads/index.php?file=videos/'+src;
		}
		else
		{
			file_url = web_url+'uploads/index.php?file='+src;
		}
		jQuery('#downloadModal').modal('show', {backdrop: 'static', keyboard: false});
		letsDownload(file_url, src, this_id);
		
		

	}
	else
	{
		jQuery('#err_text').html('');
		jQuery('#errorModal').modal('show');
		document.getElementsByClassName("modal-backdrop")[0].remove();
	}
}






$scope.start_lesson = function(section, lesson)
{
	var lesson = courseLessons.course_data[0].sections[section].lessons[lesson];
	document.getElementById('lesson_file').innerHTML = "";
	document.getElementById('lesson_title').innerHTML = lesson.title;
	document.getElementById('lesson_summary').innerHTML = lesson.summary;
	var downloadable, src="";
	if(lesson.lesson_type == "video")
{
   
    if(lesson.video_type == "html5" || lesson.video_type == "system_video")
    {
        downloadable = 1;

		src = lesson.video_url.replace("index.php/", "");
		var src_arr = src.split("/");
		src = src_arr[src_arr.length - 1];
		
	
		
		
		var lesson_html = "";

		
		







var lesson_type = "videos";

if (localStorage.getItem('offline_storage_drive') !== null) {
	var form = {};
	var driveArray = localStorage.getItem("offline_storage_drive").split("\\").filter(Boolean);
	console.log(driveArray)
	form.drive = driveArray[0];
	form.directory = driveArray[1];
	form.file = src;
	
	var req = {
		method: 'GET',
		url: 'fileCheck.php?drive='+form.drive+'&directory='+form.directory+"&file="+form.file,
		headers: {
		  'Content-Type': 'application/x-www-form-urlencoded',
		  'Accept': 'application/json'
		},
		data: $httpParamSerializer(form)
	}

	$http(req).then(function(resp){

		
		console.log(resp.data.status)

		if(resp.data.status == 1)
		{

			var linkArray = localStorage.getItem("offline_storage_drive").split('\\').filter(Boolean);
			src = 'file.php?directory='+linkArray[1]+'&drive='+linkArray[0]+'&file='+src;

			lesson_html += '<div class="video-player-container">';
        	lesson_html += '<video controls crossorigin playsinline  id="player">';                                           
        	lesson_html += '<source src="'+src+'" type="video/mp4" size="720"></video></div>';
			console.log(src)
			var temp = $compile(angular.element(lesson_html))($scope);
			angular.element(document.getElementById('lesson_file')).append(temp);
			videotypelesson();

		}
		else
		{
			var online_src = web_url+'uploads/index.php?file='+lesson_type+'/'+src;
			src = online_src;

			lesson_html += '<div class="video-player-container">';
        	lesson_html += '<video controls crossorigin playsinline  id="player">';                                           
        	lesson_html += '<source src="'+src+'" type="video/mp4" size="720"></video></div>';
			console.log(src)
			var temp = $compile(angular.element(lesson_html))($scope);
			angular.element(document.getElementById('lesson_file')).append(temp);
			videotypelesson();



		}

	}); 
}
else
{

var online_src = web_url+'uploads/index.php?file='+lesson_type+'/'+src;
		src = online_src;


		lesson_html += '<div class="video-player-container">';
        	lesson_html += '<video controls crossorigin playsinline  id="player">';                                           
        	lesson_html += '<source src="'+src+'" type="video/mp4" size="720"></video></div>';
			console.log(src)
			var temp = $compile(angular.element(lesson_html))($scope);
			angular.element(document.getElementById('lesson_file')).append(temp);
			videotypelesson();

}





			


        
    }
    else
    {
		src = lesson.video_url;
        downloadable = 0;
        var lesson_html = '<div class="video-player-container">';
        lesson_html += '<div class="plyr__video-embed mb-3" id="player">';                                           
        lesson_html += '<iframe height="500" src="'+src+'?origin=https://plyr.io&amp;iv_load_policy=3&amp;modestbranding=1&amp;playsinline=1&amp;showinfo=0&amp;rel=0&amp;enablejsapi=1" allowfullscreen allowtransparency allow="autoplay"></iframe></div></div>';
        
		console.log(src)
		var temp = $compile(angular.element(lesson_html))($scope);
		angular.element(document.getElementById('lesson_file')).append(temp);
		videotypelesson();
	
	}
   

	document.getElementById('lesson_title').style.display = "block";
	document.getElementById('lesson_summary').style.display = "block";
    document.querySelector('.row-offcanvas').classList.toggle("active");
	}
	else if(lesson.lesson_type == "other")
{
    
    if(lesson.attachment_type == "img")
    {
        downloadable = 1;
		
		
		src = lesson.attachment;
	
		var lesson_html ="";
		//src = web_url+'uploads/index.php?file='+lesson.attachment;

	
if (localStorage.getItem('offline_storage_drive') !== null) {
	var form = {};
	var driveArray = localStorage.getItem("offline_storage_drive").split("\\").filter(Boolean);
	console.log(driveArray)
	form.drive = driveArray[0];
	form.directory = driveArray[1];
	form.file = src;
	
	var req = {
		method: 'GET',
		url: 'fileCheck.php?drive='+form.drive+'&directory='+form.directory+"&file="+form.file,
		headers: {
		  'Content-Type': 'application/x-www-form-urlencoded',
		  'Accept': 'application/json'
		},
		data: $httpParamSerializer(form)
	}

	$http(req).then(function(resp){

		
		console.log(resp.data.status)

		if(resp.data.status == 1)
		{

			var linkArray = localStorage.getItem("offline_storage_drive").split('\\').filter(Boolean);
			src = 'file.php?directory='+linkArray[1]+'&drive='+linkArray[0]+'&file='+src;

			

            lesson_html = '<div id="img-zoomer-box" class="mb-3" >';
        	lesson_html += '<img src="'+src+'" id="img-1" /></div>';
			var temp = $compile(angular.element(lesson_html))($scope);
    		angular.element(document.getElementById('lesson_file')).append(temp);

		}
		else
		{
			var online_src = web_url+'uploads/index.php?file='+src;
			src = online_src;

			lesson_html = '<div id="img-zoomer-box" class="mb-3" >';
        	lesson_html += '<img src="'+src+'" id="img-1" /></div>';
			var temp = $compile(angular.element(lesson_html))($scope);
    		angular.element(document.getElementById('lesson_file')).append(temp);




		}

	}); 
}
else
{

    var online_src = web_url+'uploads/index.php?file='+src;
    src = online_src;

    lesson_html = '<div id="img-zoomer-box" class="mb-3" >';
    lesson_html += '<img src="'+src+'" id="img-1" /></div>';
    var temp = $compile(angular.element(lesson_html))($scope);
    angular.element(document.getElementById('lesson_file')).append(temp);

}
        
    }
    else
    {

		src = lesson.attachment;


        downloadable = 1;
		
if (localStorage.getItem('offline_storage_drive') !== null) {
	var form = {};
	var driveArray = localStorage.getItem("offline_storage_drive").split("\\").filter(Boolean);
	console.log(driveArray)
	form.drive = driveArray[0];
	form.directory = driveArray[1];
	form.file = src;
	
	var req = {
		method: 'GET',
		url: 'fileCheck.php?drive='+form.drive+'&directory='+form.directory+"&file="+form.file,
		headers: {
		  'Content-Type': 'application/x-www-form-urlencoded',
		  'Accept': 'application/json'
		},
		data: $httpParamSerializer(form)
	}

	$http(req).then(function(resp){

		
		console.log(resp.data.status)

		if(resp.data.status == 1)
		{

			var linkArray = localStorage.getItem("offline_storage_drive").split('\\').filter(Boolean);
			src = 'pdf.php?directory='+linkArray[1]+'&drive='+linkArray[0]+'&file='+src;
			var form_data = {};
			var req = {
				method: 'GET',
				url: src,
				headers: {
				  'Content-Type': 'application/x-www-form-urlencoded',
				  'Accept': 'application/json'
				},
				data: $httpParamSerializer(form_data)
			}
		
			$http(req).then(function(resp){


				var lesson_html = '<div id="pdf-box" class="mb-3" >';
            lesson_html += '<iframe src="data/other/pdf/web/pdfviewer.php" style="width:100%; height:500px; border:none;"  style="border: 1px solid black;"></iframe></div>';
            var temp = $compile(angular.element(lesson_html))($scope);
            angular.element(document.getElementById('lesson_file')).append(temp);


/*
				var form_data = {};
				form_data.bs64 = resp.data.status;

				var req = {
					method: 'POST',
					url: 'data/other/pdf/web/pdfviewer.php',
					headers: {
					  'Content-Type': 'application/x-www-form-urlencoded',
					  'Accept': 'application/json'
					},
					data: $httpParamSerializer(form_data)
				}
			
				$http(req).then(function(resp){
	
	
	
				});

*/

			});

/*
			var lesson_html = '<div id="pdf-box" class="mb-3" >';
            lesson_html += '<iframe src="data/other/pdf/web/viewer.html?file='+src+'" style="width:100%; height:500px; border:none;"  style="border: 1px solid black;"></iframe></div>';
            var temp = $compile(angular.element(lesson_html))($scope);
            angular.element(document.getElementById('lesson_file')).append(temp);  */

            
		}
		else
		{
			var online_src = web_url+'uploads/index.php?file='+src;
			src = online_src;

            var lesson_html = '<div id="pdf-box" class="mb-3" >';
            lesson_html += '<iframe src="data/other/pdf/web/viewer.html?file='+src+'" style="width:100%; height:500px; border:none;"  style="border: 1px solid black;"></iframe></div>';
            var temp = $compile(angular.element(lesson_html))($scope);
            angular.element(document.getElementById('lesson_file')).append(temp);



		}

	}); 
}
else
{

    var online_src = web_url+'uploads/index.php?file='+src;
    src = online_src;

    var lesson_html = '<div id="pdf-box" class="mb-3" >';
    lesson_html += '<iframe src="data/other/pdf/web/viewer.html?file='+src+'" style="width:100%; height:500px; border:none;"  style="border: 1px solid black;"></iframe></div>';
    var temp = $compile(angular.element(lesson_html))($scope);
    angular.element(document.getElementById('lesson_file')).append(temp);

}
	}

    
	document.getElementById('lesson_title').style.display = "block";
	document.getElementById('lesson_summary').style.display = "block";
    document.querySelector('.row-offcanvas').classList.toggle("active");
    
	}
	else
{
    downloadable = 0;
    src = "";
	document.getElementById('lesson_title').style.display = "none";
	document.getElementById('lesson_summary').style.display = "none";
    var alertPopup = $ionicPopup.alert({
        title: "Ops, Can't access on App",
        template: "Visit "+web_url
    }); 
	}
	
	document.getElementById('lesson_container').style.display = "block";
	document.getElementById('lesson_container').scrollIntoView();

	//tracking
	lc_obj_index = lc_sessions.findIndex((obj => obj.id === lc_session_id));


			if($rootScope.last_course_id > 0 && $rootScope.last_lesson_id > 0)
			{
				lc_course_obj_index = lc_sessions[lc_obj_index].data.page_data.findIndex((obj => obj.course_id === $rootScope.last_course_id));
				var lesson_data_obj_index = lc_sessions[lc_obj_index].data.page_data[lc_course_obj_index].lesson.findIndex((obj => obj.lesson_id === $rootScope.last_lesson_id));
				lc_sessions[lc_obj_index].data.page_data[lc_course_obj_index].lesson[lesson_data_obj_index].end_time = new Date().getTime();
			}


			lc_course_obj_index = lc_sessions[lc_obj_index].data.page_data.findIndex((obj => obj.course_id === $rootScope.course_id));

			var lesson_data_arr = lc_sessions[lc_obj_index].data.page_data[lc_course_obj_index].lesson;

			

			lesson_data_arr.push({
				section_id: courseLessons.course_data[0].sections[section].id,
				section_title: courseLessons.course_data[0].sections[section].title,
				lesson_id: lesson.id,
				lesson: lesson.title.trim(),
				lesson_type: lesson.lesson_type,
				at_time : new Date().getTime(),
				end_time : ""
			});

			lc_sessions[lc_obj_index].data.page_data[lc_course_obj_index].lesson = lesson_data_arr;
			localStorage.setItem("lc_sessions", JSON.stringify(lc_sessions));
			
			$rootScope.last_course_id = $rootScope.course_id;
			$rootScope.last_lesson_id = lesson.id;

	//tracking



}



		} catch(e){
			console.log("%cerror: %cPage: `my_orders` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: orderCtrl --|-- 
.controller("orderCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "page_builder" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: orderCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: orderCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: orderCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// TODO: orderCtrl --|-- $scope.showAuthentication
	$scope.showAuthentication  = function(){
		var form = {"uname":"demo","pwd":"demo"};
		$scope.form = {};
		var authPopup = $ionicPopup.show({
			template: '<input type="text" ng-model="form.uname" placeholder="Username"><input type="password" placeholder="Password" ng-model="form.pwd">',
			title: "Authorization",
			subTitle: "Please use username and password",
			scope: $scope,
			buttons: [
				{text:"Cancel",onTap: function(e){
					$state.go("wah_meal.dashboard");
				}},
				{text:"<strong>Save</strong>",type:"button-positive",onTap:function(e){
						return $scope.form;
					}},
			],
		}).then(function(form){
			if( angular.isDefined(form)){
				var uname = form.uname || "demo";
				var pwd = form.pwd || "demo";
				var http_value = "Basic " + base64.encode(uname + ":" + pwd);
				$http.defaults.headers.common["Authorization"] = http_value;
				localforage.setItem("ima_session", JSON.stringify(http_value));
				$scope.doRefresh();
			}
		},function(err){
		},function(msg){
		});
	};
	
	// set default parameter http
	var http_params = {};
	
	// set HTTP Header 
	var http_header = {
		headers: {
		},
		params: http_params
	};
	var targetQuery = ""; //default param
	var raplaceWithQuery = "";
	//fix url History
	targetQuery = "json=order"; //default param
	raplaceWithQuery = "json=order";
	
	
	// TODO: orderCtrl --|-- $scope.splitArray
	$scope.splitArray = function(items,cols,maxItem) {
		var newItems = [];
		if(maxItem == 0){
			maxItem = items.length;
		}
		if(items){
			for (var i=0; i < maxItem; i+=cols) {
				newItems.push(items.slice(i, i+cols));
			}
		}
		return newItems;
	}
	$scope.gmapOptions = {options: { scrollwheel: false }};
	
	var fetch_per_scroll = 1;
	// animation loading 
	$ionicLoading.show();
	
	
	// TODO: orderCtrl --|-- $scope.fetchURL
	$scope.fetchURL = "https://www.wahmeal.in/cust_app/rest-api.php?json=order";
	// TODO: orderCtrl --|-- $scope.fetchURLp
	$scope.fetchURLp = "https://www.wahmeal.in/cust_app/rest-api.php?json=order&callback=JSON_CALLBACK";
	// TODO: orderCtrl --|-- $scope.hashURL
	$scope.hashURL = md5.createHash( $scope.fetchURL.replace(targetQuery,raplaceWithQuery));
	
	
	$scope.noMoreItemsAvailable = false; //readmore status
	var lastPush = 0;
	var data_orders = [];
	
	localforage.getItem("data_orders_" + $scope.hashURL, function(err, get_orders){
		if(get_orders === null){
			data_orders =[];
		}else{
			data_orders = JSON.parse(get_orders);
			$scope.data_orders =JSON.parse( get_orders);
			$scope.orders = [];
			for(lastPush = 0; lastPush < 100; lastPush++) {
				if (angular.isObject(data_orders[lastPush])){
					$scope.orders.push(data_orders[lastPush]);
				};
			}
			$timeout(function() {
				$ionicLoading.hide();
				controller_by_user();
			},200);
		}
	}).then(function(value){
	}).catch(function (err){
	})
	if(data_orders === null ){
		data_orders =[];
	}
	if(data_orders.length === 0 ){
		$timeout(function() {
			var url_request = $scope.fetchURL.replace(targetQuery,raplaceWithQuery);
			// overwrite HTTP Header 
			http_header = {
				headers: {
				},
				params: http_params
			};
			// TODO: orderCtrl --|-- $http.get
			$http.get(url_request,http_header).then(function(response) {
				data_orders = response.data;
				$scope.data_orders = response.data;
				// TODO: orderCtrl --|---------- set:localforage
				localforage.setItem("data_orders_" + $scope.hashURL, JSON.stringify(data_orders));
				$scope.orders = [];
				for(lastPush = 0; lastPush < 100; lastPush++) {
					if (angular.isObject(data_orders[lastPush])){
						$scope.orders.push(data_orders[lastPush]);
					};
				}
			},function(response) {
			
				$timeout(function() {
					var url_request = $scope.fetchURLp.replace(targetQuery,raplaceWithQuery);
					// overwrite HTTP Header 
					http_header = {
						headers: {
						},
						params: http_params
					};
					// TODO: orderCtrl --|------ $http.jsonp
					$http.jsonp(url_request,http_header).success(function(data){
						data_orders = data;
						$scope.data_orders = data;
						$ionicLoading.hide();
						// TODO: orderCtrl --|---------- set:localforage
						localforage.setItem("data_orders_" + $scope.hashURL,JSON.stringify(data_orders));
						controller_by_user();
						$scope.orders = [];
						for(lastPush = 0; lastPush < 100; lastPush++) {
							if (angular.isObject(data_orders[lastPush])){
								$scope.orders.push(data_orders[lastPush]);
							};
						}
					}).error(function(data){
					if(response.status ===401){
						// TODO: orderCtrl --|------------ error:Unauthorized
						$scope.showAuthentication();
					}else{
						// TODO: orderCtrl --|------------ error:Message
						var data = { statusText:response.statusText, status:response.status };
						var alertPopup = $ionicPopup.alert({
							title: "Network Error" + " (" + data.status + ")",
							template: "An error occurred while collecting data.",
						});
						$timeout(function() {
							alertPopup.close();
						}, 2000);
					}
					});
				}, 200);
		}).finally(function() {
			$scope.$broadcast("scroll.refreshComplete");
			// event done, hidden animation loading
			$timeout(function() {
				$ionicLoading.hide();
				controller_by_user();
				if(angular.isDefined($scope.data_orders.data)){
					if($scope.data_orders.data.status ===401){
						$scope.showAuthentication();
						return false;
					}
				}
			}, 200);
		});
	
		}, 200);
	}
	
	
	// TODO: orderCtrl --|-- $scope.doRefresh
	$scope.doRefresh = function(){
		var url_request = $scope.fetchURL.replace(targetQuery,raplaceWithQuery);
		// retry retrieving data
		// overwrite http_header 
		http_header = {
			headers: {
			},
			params: http_params
		};
		// TODO: orderCtrl --|------ $http.get
		$http.get(url_request,http_header).then(function(response) {
			data_orders = response.data;
			$scope.data_orders = response.data;
			// TODO: orderCtrl --|---------- set:localforage
			localforage.setItem("data_orders_" + $scope.hashURL,JSON.stringify(data_orders));
			$scope.orders = [];
			for(lastPush = 0; lastPush < 100; lastPush++) {
				if (angular.isObject(data_orders[lastPush])){
					$scope.orders.push(data_orders[lastPush]);
				};
			}
		},function(response){
			
		// retrieving data with jsonp
			$timeout(function() {
			var url_request =$scope.fetchURLp.replace(targetQuery,raplaceWithQuery);
				// overwrite http_header 
				http_header = {
					headers: {
					},
					params: http_params
				};
				// TODO: orderCtrl --|---------- $http.jsonp
				$http.jsonp(url_request,http_header).success(function(data){
					data_orders = data;
					$scope.data_orders = data;
					$ionicLoading.hide();
					controller_by_user();
					// TODO: orderCtrl --|---------- set:localforage
					localforage.setItem("data_orders_"+ $scope.hashURL,JSON.stringify(data_orders));
					$scope.orders = [];
					for(lastPush = 0; lastPush < 100; lastPush++) {
						if (angular.isObject(data_orders[lastPush])){
							$scope.orders.push(data_orders[lastPush]);
						};
					}
				}).error(function(resp){
					if(response.status ===401){
						// TODO: orderCtrl --|------------ error:Unauthorized
						$scope.showAuthentication();
					}else{
						// TODO: orderCtrl --|------------ error:Message
						var data = { statusText:response.statusText, status:response.status };
						var alertPopup = $ionicPopup.alert({
							title: "Network Error" + " (" + data.status + ")",
							template: "An error occurred while collecting data.",
						});
					};
				});
			}, 200);
		}).finally(function() {
			$scope.$broadcast("scroll.refreshComplete");
			// event done, hidden animation loading
			$timeout(function() {
				$ionicLoading.hide();
				controller_by_user();
				if(angular.isDefined($scope.data_orders.data)){
					if($scope.data_orders.data.status ===401){
						$scope.showAuthentication();
						return false;
					}
				}
			}, 500);
		});
	
	};
	if (data_orders === null){
		data_orders = [];
	};
	// animation readmore
	var fetchItems = function() {
		for(var z=0;z<fetch_per_scroll;z++){
			if (angular.isObject(data_orders[lastPush])){
				$scope.orders.push(data_orders[lastPush]);
				lastPush++;
			}else{;
				$scope.noMoreItemsAvailable = true;
			}
		}
		$scope.$broadcast("scroll.infiniteScrollComplete");
	};
	
	// event readmore
	$scope.onInfinite = function() {
		$timeout(fetchItems, 500);
	};
	
	// create animation fade slide in right (ionic-material)
	$scope.fireEvent = function(){
		ionicMaterialInk.displayEffect();
	};
	
	// Form Request
	// code 

	// TODO: orderCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
main_side_nav()			
		} catch(e){
			console.log("%cerror: %cPage: `order` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: page1Ctrl --|-- 
.controller("page1Ctrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: page1Ctrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: page1Ctrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: page1Ctrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: page1Ctrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()
$scope.$on("$ionicView.afterEnter", function (){ 
	iuser_id = $rootScope.current_user.uname;
	document.getElementById('iframe_refund').src = "https://wahmeal.in/cust_app/refund-policy.php";

 });			
		} catch(e){
			console.log("%cerror: %cPage: `page1` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: page2Ctrl --|-- 
.controller("page2Ctrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: page2Ctrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: page2Ctrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: page2Ctrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: page2Ctrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()
$scope.$on("$ionicView.afterEnter", function (){ 
	iuser_id = $rootScope.current_user.uname;
	document.getElementById('iframe_privacy').src = "https://wahmeal.in/cust_app/privacy-policy.php";

 });			
		} catch(e){
			console.log("%cerror: %cPage: `page2` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: page3Ctrl --|-- 
.controller("page3Ctrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: page3Ctrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: page3Ctrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: page3Ctrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: page3Ctrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()			
		} catch(e){
			console.log("%cerror: %cPage: `page3` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: page4Ctrl --|-- 
.controller("page4Ctrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: page4Ctrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: page4Ctrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: page4Ctrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: page4Ctrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()			
		} catch(e){
			console.log("%cerror: %cPage: `page4` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: page5Ctrl --|-- 
.controller("page5Ctrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: page5Ctrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: page5Ctrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: page5Ctrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: page5Ctrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()			
		} catch(e){
			console.log("%cerror: %cPage: `page5` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: page6Ctrl --|-- 
.controller("page6Ctrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: page6Ctrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: page6Ctrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: page6Ctrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: page6Ctrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()			
		} catch(e){
			console.log("%cerror: %cPage: `page6` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: page7Ctrl --|-- 
.controller("page7Ctrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: page7Ctrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: page7Ctrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: page7Ctrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: page7Ctrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()			
		} catch(e){
			console.log("%cerror: %cPage: `page7` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: page8Ctrl --|-- 
.controller("page8Ctrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: page8Ctrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: page8Ctrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: page8Ctrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: page8Ctrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");
main_side_nav()			
		} catch(e){
			console.log("%cerror: %cPage: `page8` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: profileCtrl --|-- 
.controller("profileCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "page_builder" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
		
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: profileCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: profileCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: profileCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: profileCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
     main_side_nav()
$scope.current_user = {} ;
$scope.$on("$ionicView.afterEnter", function (){  
    
   //$ionicLoading.show();

		if (localStorage.getItem('offline_storage_drive') !== null) {

			document.getElementById("offline_storage").value = localStorage.getItem('offline_storage_drive');

		}
   

});   


$rootScope.logoutUser = function(){
    delete $rootScope.current_user ;
    delete $scope.current_user ;
    
    var http_value = {};
    
    localforage.setItem("ima_session", JSON.stringify(http_value));    


//Save session file -login
var form = {};
form.file_data = JSON.stringify({ima_session:''});

var req = {
	method: 'POST',
	url:'sessionFiles.php?create_session_file=loginSession',
	headers: {
	  'Content-Type': 'application/x-www-form-urlencoded',
	  'Accept': 'application/json'
	},
	data: $httpParamSerializer(form)
}

$http(req).then(function(resp){
	if(resp.data.status == 1)
	{
		console.log('loginSession logout file created');
	}
});

    
      $ionicHistory.nextViewOptions({
        disableAnimate: true,
        disableBack: true
    });
    
    $state.go("wah_meal.form_login");
}

$rootScope.setOfflineDrive = function(){

	localStorage.setItem("offline_storage_drive", document.getElementById("offline_storage").value);
	alert("Configuration saved!!!");
}


//tracking
lc_obj_index = lc_sessions.findIndex((obj => obj.id === lc_session_id));
if($rootScope.last_course_id > 0 && $rootScope.last_lesson_id > 0)
{
	lc_course_obj_index = lc_sessions[lc_obj_index].data.page_data.findIndex((obj => obj.course_id === $rootScope.last_course_id));
	var lesson_data_obj_index = lc_sessions[lc_obj_index].data.page_data[lc_course_obj_index].lesson.findIndex((obj => obj.lesson_id === $rootScope.last_lesson_id));
	lc_sessions[lc_obj_index].data.page_data[lc_course_obj_index].lesson[lesson_data_obj_index].end_time = new Date().getTime();
	localStorage.setItem("lc_sessions", JSON.stringify(lc_sessions));
}


    
$rootScope.updateUser = function(){
  		
    // animation loading 
    $ionicLoading.show({
    	template: '<div class="loader"><svg class="circular"><circle class="path" cx="50" cy="50" r="20" fill="none" stroke-width="2" stroke-miterlimit="10"/></svg></div>'
    });
	
		var $messages, $title = null;
		$http({
				method:"POST",
				url: "https://www.wahmeal.in/cust_app/rest-api.php?json=submit&form=me",
				data: $httpParamSerializer($scope.current_user),   
				headers: {"Content-Type":"application/x-www-form-urlencoded"}  
			})
			.then(function(response) {
				$messages = response.data.message;
				$title = response.data.title;
			},function(response){
				$messages = response.statusText;
				$title = response.status;
			}).finally(function(){
				// event done, hidden animation loading
				$timeout(function() {
					$ionicLoading.hide();
					if($messages !== null){
						// message
    					var alertPopup = $ionicPopup.alert({
    						title: $title,
    						template: $messages,
    					});
					}
			     }, 500);
		  });
}
 
			
		} catch(e){
			console.log("%cerror: %cPage: `profile` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: restaurantCtrl --|-- 
.controller("restaurantCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "page" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: restaurantCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: restaurantCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: restaurantCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: restaurantCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
main_side_nav()
$scope.$on("$ionicView.afterEnter", function (){ 
	iuser_id = $rootScope.current_user.uname;
	restaurant_id = $rootScope.restaurant_id;
	document.getElementById('iframe_restaurant').src = "https://wahmeal.in/cust_app/restaurant.php?username="+iuser_id+"&restaurant="+restaurant_id;

 });			
		} catch(e){
			console.log("%cerror: %cPage: `restaurant` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: slide_tab_menuCtrl --|-- 
.controller("slide_tab_menuCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "menu" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: slide_tab_menuCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: slide_tab_menuCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: slide_tab_menuCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: slide_tab_menuCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
$ionicConfig.backButton.text("");			
		} catch(e){
			console.log("%cerror: %cPage: `slide_tab_menu` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})

// TODO: trackCtrl --|-- 
.controller("trackCtrl", function($ionicConfig,$scope,$rootScope,$state,$location,$ionicScrollDelegate,$ionicListDelegate,$http,$httpParamSerializer,$stateParams,$timeout,$interval,$ionicLoading,$ionicPopup,$ionicPopover,$ionicActionSheet,$ionicSlideBoxDelegate,$ionicHistory,ionicMaterialInk,ionicMaterialMotion,$window,$ionicModal,base64,md5,$document,$sce,$ionicGesture,$translate,tmhDynamicLocale){
	
	$rootScope.headerExists = false;
	$rootScope.ionWidth = $document[0].body.querySelector(".view-container").offsetWidth || 412;
	$rootScope.grid64 = parseInt($rootScope.ionWidth / 64) ;
	$rootScope.grid80 = parseInt($rootScope.ionWidth / 80) ;
	$rootScope.grid128 = parseInt($rootScope.ionWidth / 128) ;
	$rootScope.grid256 = parseInt($rootScope.ionWidth / 256) ;
	$rootScope.last_edit = "page" ;
	$scope.$on("$ionicView.afterEnter", function (){
		var page_id = $state.current.name ;
		$rootScope.page_id = page_id.replace(".","-") ;
	});
	if($rootScope.headerShrink == true){
		$scope.$on("$ionicView.enter", function(){
			$scope.scrollTop();
		});
	};
	// TODO: trackCtrl --|-- $scope.scrollTop
	$rootScope.scrollTop = function(){
		$timeout(function(){
			$ionicScrollDelegate.$getByHandle("top").scrollTop();
		},100);
	};
	// TODO: trackCtrl --|-- $scope.toggleGroup
	$scope.toggleGroup = function(group) {
		if ($scope.isGroupShown(group)) {
			$scope.shownGroup = null;
		} else {
			$scope.shownGroup = group;
		}
	};
	
	$scope.isGroupShown = function(group) {
		return $scope.shownGroup === group;
	};
	
	// TODO: trackCtrl --|-- $scope.redirect
	// redirect
	$scope.redirect = function($url){
		$window.location.href = $url;
	};
	
	// Set Motion
	$timeout(function(){
		ionicMaterialMotion.slideUp({
			selector: ".slide-up"
		});
	}, 300);
	// code 

	// TODO: trackCtrl --|-- controller_by_user
	// controller by user 
	function controller_by_user(){
		try {
			
main_side_nav()
$scope.$on("$ionicView.afterEnter", function (){ 
	iuser_id = $rootScope.current_user.uname;
	document.getElementById('iframe_track').src = "https://wahmeal.in/cust_app/track.php?username="+iuser_id;

 });			
		} catch(e){
			console.log("%cerror: %cPage: `track` and field: `Custom Controller`","color:blue;font-size:18px","color:red;font-size:18px");
			console.dir(e);
		}
	}
	$scope.rating = {};
	$scope.rating.max = 5;
	
	// animation ink (ionic-material)
	ionicMaterialInk.displayEffect();
	controller_by_user();
})
