<?php
session_start();
define('FILE_ENCRYPTION_BLOCKS', 10000);

if(!isset($_SESSION["current_dec_file"])){
  foreach (glob(sys_get_temp_dir()."\LC-*.tmp") as $filename) {
    $cmd = 'del "'.$filename.'"';
    exec($cmd);
  }
}

function decryptFileTemp($source, $key, $file_name_without_ext)
{
    $key = substr(sha1($key, true), 0, 16);

    $error = false;

    $prefix = "LC-";


    if(isset($_SESSION["current_dec_file"]) && $_SESSION["current_dec_file"]["name"] == $file_name_without_ext){
      return $_SESSION["current_dec_file"]["path"];
    }else{
      //unlink($_SESSION["current_dec_file"]["path"]);
      $cmd = 'del "'.$_SESSION["current_dec_file"]["path"].'"';
      exec($cmd);
    }


    $dest = tempnam(sys_get_temp_dir(), $prefix);
    if ($fpOut = fopen($dest, 'w')) {
        if ($fpIn = fopen($source, 'rb')) {
            // Get the initialzation vector from the beginning of the file
            $iv = fread($fpIn, 16);
            while (!feof($fpIn)) {
                $ciphertext = fread($fpIn, 16 * (FILE_ENCRYPTION_BLOCKS + 1)); // we have to read one block more for decrypting than for encrypting
                $plaintext = openssl_decrypt($ciphertext, 'AES-128-CBC', $key, OPENSSL_RAW_DATA, $iv);
                // Use the first 16 bytes of the ciphertext as the next initialization vector
                $iv = substr($ciphertext, 0, 16);
                fwrite($fpOut, $plaintext);
            }
            $_SESSION["current_dec_file"]["name"] = $file_name_without_ext;
            $_SESSION["current_dec_file"]["path"] = $dest;
            fclose($fpIn);
        } else {
            $error = true;
        }
        fclose($fpOut);
    } else {
        $error = true;
    }

    return $error ? false : $dest;
}









if(isset($_GET['file']) && isset($_GET['drive']))
{

$drive = $_GET['drive'];
$directory = $_GET['directory'];
$file = $_GET['file'];
$dec_filename = explode('.', $file);
$filename = $drive.'/'.$directory.'/'.$dec_filename[0].'.okcl';

$video_exts = array('mp4', 'MP4', 'avi', 'AVI', 'mov', 'MOV', 'mkv', 'MKV', 'wmv', 'WMV', 'swf', 'SWF', 'wemb', 'WEMB'); 

$key = '0kcl@LC';

      if (file_exists($filename)) {

        
        if(in_array(end($dec_filename), $video_exts))
        {

          
          $dec_file = decryptFileTemp($filename, $key, $dec_filename[0]);
        
          include 'VideoStream.php';
          $stream = new VideoStream($dec_file);
          $stream->start();
        
        }
        else
        {

          $dec_file = decryptFileTemp($filename, $key, $dec_filename[0]);
          
            $bs64 = base64_encode(file_get_contents($dec_file));
            $_SESSION["pdf"] = $bs64;
            echo json_encode(array("status"=>$bs64));
        }
        
       

      }
      else
      {
        echo 404;
      }
    


}
else
{

    echo 500;

}
